{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden DOKU.   (C)1989-1996, DG9EP
 -}

UNIT BID;

{$I monisys.inc}

Interface

USES  Crt,Dos, PortPAS,
      fd_div, crc,  MO_DEF

      {$IFDEF bp2} ,bsedos {$ENDIF}
      {$IFDEF vp } {$IFDEF PMVersion} ,wincrt {$ENDIF} ,os2base {$ENDIF}
      ;

 TYPE T_BID = PACKED RECORD
        BID : STRING[24];
        fKomplett : BOOLEAN;
       END;

  VAR  BIDResult : INTEGER;

  CONST cCHECKFIRST=TRUE;
        cNOCHECK   =FALSE;

PROCEDURE InsertBID ( CONST sBID : STRING; fCheckFirst:BOOLEAN );
 FUNCTION SearchBID ( CONST sBID : STRING; VAR rBID:T_BID ) : BOOLEAN;

{--------------------------------------------------------------------------}

IMPLEMENTATION

{$I-}
VAR hdlBID : FILE {$IFDEF TypedFile}OF T_BID{$ENDIF};
CONST fOpen : BOOLEAN = FALSE;

PROCEDURE OpenBIDFile;
BEGIN
  BIDResult := 0;
  IF fOpen THEN Exit;
  IF CheckDirName(sBBSDir) > 99 THEN ;;
  Assign(hdlBID,sBBSDir+'\BID.MON');
  Reset(hdlBID{$IFnDEF TypedFile},1 {$ENDIF} );
  BIDResult := IOResult;
  IF (BIDResult = 2) OR (BIDResult = 3) THEN
    BEGIN
    Rewrite(hdlBID {$IFnDEF TypedFile},1 {$ENDIF});
    BIDResult := IOResult;
    END;
  IF BIDResult <> 0 THEN Exit;
  fOpen := true;
END;


FUNCTION SearchBID ( CONST sBID : STRING; VAR rBID:T_BID ) : BOOLEAN;
  VAR x : T_BID;
BEGIN
  {* Lineare Suche! Wenns zulangsam wird kann man es ja ndern *}
  SearchBID := false;
  OpenBIDFile;
  IF BIDResult <> 0 THEN Exit;
  Seek(hdlBID,0 {$IFnDEF TypedFile}*sizeof(t_BID) {$ENDIF});
  WHILE NOT EOF(hdlBID) DO
    BEGIN
    {$IFDEF TypedFile}
      Read(hdlBID,x);
    {$ELSE}
      Blockread(hdlBID,x,sizeof(x) );
    {$ENDIF}
    IF IOResult <> 0 THEN Break;
    IF x.bid = sBID THEN BEGIN
                         SearchBID := true;
                         rBID := x;
                         Exit;
                         END;
    END;
END;


PROCEDURE InsertBID ( CONST sBID : STRING; fCheckFirst:BOOLEAN );
  VAR x : T_BID;
BEGIN
  BidResult := 1002;
  IF sBID='' THEN Exit;
  BidResult := 0;
  OpenBIDFile;
  IF BIDResult <> 0 THEN Exit;
  IF fCheckFirst THEN
    IF SearchBID(sBID,x) THEN
      BEGIN {* Hammer schon ... *}
      BidResult := 1001;
      Exit;
      END;
  Seek( hdlBID, FileSize(hdlBID) );

  FillChar(x,sizeof(x),#0);
  x.bid := sBID;
  {$IFDEF TypedFile}
    Write(hdlBID, x);
  {$ELSE}
    BlockWrite( hdlBID, x, sizeof(x) );
  {$ENDIF}
END;



  VAR ExitSave : Pointer;
PROCEDURE DoExit; FAR;
BEGIN
  IF fOpen THEN
    BEGIN
    Close(hdlBID);
    IF IOResult <> 0 THEN Writeln('IO-Fehler beim Schliessen von BID.MON');
    END;
  Exitproc := exitSave;
END;



BEGIN
  exitsave := exitproc;
  exitproc := @doexit;
END.

