{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt.
 - (C)1989-1997, DG9EP
 -
 - Dieser Quelltext entstand aus dem FlxApp-Demoprogramm von Michael
 - Pospiezsynski
 -}
PROGRAM MoniPCF3(input,output);
{$I monisys.inc}
{$M 16384,0,655360}

{$IFDEF Windows}  !!! Compile/Target... Real         !!! {$ENDIF}
{$IFDEF OS2    }  !!! Compile/Target... Real         !!! {$ENDIF}


USES Monitor, fd_div, dump, ToolMoni, Mo_def,
     Flxapp,
     CRT,DOS;

FUNCTION MkCallStr (FCall:tFlxCall):String;
  VAR s,s2 : STRING[9];
      i : WORD;
BEGIN
 s := '';
 FOR i := 0 TO 5 DO
   IF FCall[i]<=' ' THEN Break
                    ELSE s:=s+FCall[i];
 IF FCall[6] > '0' THEN
   BEGIN
   Str( Ord(Fcall[6])-48, s2);
   s := s + '-' + s2;
   END;
 MkCallStr := s;
END;

{--------------------------------------------------------}

FUNCTION Send(qsoNr:WORD; CONST s:STRING):BOOLEAN;
BEGIN
  Send := FALSE;
  IF l2_ialloc (QsoNr, length(s)) THEN
    BEGIN
    l2_send_str (QsoNr, s);
    Send := True;
    END;
END;
PROCEDURE PSend(qsoNr:word; CONST s:STRING);
BEGIN
  IF Send( qsonr,s) THEN;;;
END;


FUNCTION Frame2String(pInfoFrame:pInfo):STRING;
  VAR s : STRING;
      i : WORD;
BEGIN
  s := '';
  WITH pInfoFrame^ DO
    FOR i := 1 TO length DO
      IF Text[i] = #13 THEN Break
                       ELSE s := s + Text[i];
  Frame2String := s;
END;

{--------------------------------------------------------}

  VAR strucHeader : t_hheader;
      sHeader : String;
PROCEDURE PollMonitor;
  VAR pMonFrame : pFrame;
      sTyp : STRING;
      i : WORD;
BEGIN
  pMonFrame := l2_get_monitor;
  IF pMonFrame = NIL THEN Exit; {* nix gekommen! *}
  WITH pMonFrame^ DO
    BEGIN
    sHeader := F_Str (Kanal)
             + ':fm '+mkcallstr (source)
             + ' to '+mkcallstr (dest)  ;
    if Digis > 0 then
      begin
      AddString(sHeader, ' via');
      FOR i := 1 to Digis DO
        AddString(sHeader, ' '+mkcallStr(digi[i]) );
      END;
    sTyp := '';
    case typ of
      Fr_I   : sTyp := 'I'+F_Str(nr)+F_Str(ns);
      Fr_RR  : sTyp :='RR'+F_Str(nr);
      Fr_RNR : sTyp :='RNR'+F_Str(nr);
      Fr_REJ : sTyp :='REJ'+F_Str(nr);
      Fr_SABM: sTyp :='SABM';
      Fr_DISC: sTyp :='DISC';
      Fr_DM  : sTyp :='DM';
      Fr_UA  : sTyp :='UA';
      Fr_FRMR: sTyp :='FRMR';
      Fr_UI  : sTyp :='UI';
      end;
    AddString(sHeader, ' ctl '+sTyp );
    IF textlen > 0 THEN AddString(sHeader,' pid '+ HexByteString(pid) );
             {Write (' txd:',txdelay, ' (',qsonum, '>', Partner_num, ')');}
    IF dama <> 0 then AddString(sHeader, ' [DAMA]');
    Auswerten(output, sHeader, tp_aDaten(text)^, textlen, strucHeader);
    l2_ack_monitor;
    END;
END;

{---------------------------------------------------------}

CONST sMyCall : STRING = '';
      MAXQSO = 10;
TYPE T_QSO = RECORD
               QSOnr : WORD;
               fLinkSetup : BOOLEAN;
              END;
VAR aQSO : ARRAY [1..MAXQSO] OF T_QSO;


PROCEDURE SendSpySummary(qsonr:word);
  VAR i : WORD;
BEGIN
  PSend(qsonr,#13);
  FOR i := 1 TO maxSpy DO
    IF aSpy[i].Id <> 0 THEN
      BEGIN
      WITH aSpy[i].sammler[true] DO
        PSEND(QsoNr, aSpy[i].scallFm + ' > ' + aSpy[i].scallTo
                    + '  '
                    + F_LiStr(nNettoBytes)
                    + '/'
                    + F_LiStr(nBruttoBytes)
                    + ' Byte '
                    + #13);
      END;
  l2_pack (QsoNr);
END;



PROCEDURE PollQSO;
  VAR qi,i,dummy,status : WORD;
      pInfoFrame : pINfo;
      sResp : STRING;
BEGIN
  IF sMyCall = '' THEN Exit;
  { Prfen ob SABM fr MyCall empfangen }
  Dummy := l2_pget_Sabm (sMyCall);
  IF Dummy > 0 THEN { Es wurde ein SABM empfangen ! }
    BEGIN
    {* Suchen nach Platz fr QSO *}
    FOR i := 1 TO MAXQSO DO
      IF aQSO[i].QSoNr = 0 THEN Break;

    IF i<=MAXQSO
      THEN BEGIN
           WITH aQSO[i] DO
             BEGIN
             QsoNr := Dummy;       { Nein, dann QSO annehmen }
             L2_set_linemode (qsonr);
             l2_sabmresp (QsoNr);  { und UA senden }
             fLinkSetup := TRUE;   { fr *** connected to ... }
             IF Send(QsoNr, '*** Moin, Gugger '+f_str(i)+'. hier laeuft grade '+sPgmName+' '+sPgmVersion+#13) THEN;;;;
             SendSpySummary(qsoNr);
             END
           END
      ELSE BEGIN
           l2_sabm_dm (Dummy); { Sonst mit DM ablehnen }
           END;
    END;

  FOR qi := 1 TO MAXQSO DO WITH aQSO[qi] DO
    IF QsoNr > 0 THEN { Besteht eine Verbindung? }
      BEGIN
      Status := l2_State (QsoNr); { Status abfragen }
      IF Status = 1 THEN QsoNr := 0; { DISC oder DM von auen }
      IF (Status >= 5) AND fLinkSetup THEN fLinkSetup := FALSE;
      IF Status = 0 THEN QsoNr := 0; {* War wohl doch kein QSO da *}

      IF (Status AND $40) = $40 THEN
        BEGIN { I-Frame empfangen }
        pInfoFrame := l2_get_i (QsoNr); { Daten abholen (I-Frame) }
        l2_I_Ack (QsoNr); { I-Frame besttigen. }
        sResp := Frame2String(pInfoFrame);
        CASE upcase(sResp[1]) OF
          'Q' : BEGIN
                PSend(QsoNr, ' und tschuess ...'+#13);
                l2_stop_qso (qsonr);
                END;
          'S' : SendSpySummary(qsonr);
          'U' : BEGIN FOR i := 1 TO maxQSO DO
                  IF aqso[i].qsonr>0 THEN PSend(QsoNr, ' '+F_Str(aqso[i].qsonr) +#13);
                  {...todo...}
                l2_pack(qsoNr);
                END
           ELSE BEGIN{IF DoReadKey(sResp[1]) THEN;;};
                PSend(QSONr, 'q)uit  s)pyzusammenfassung u)ser'+#13);
                l2_pack(qsoNr);
                END;
          END;
        END
      END; { Besteht eine Verbindung? }
END;


PROCEDURE DoMonitor;
  VAR fPrgEnde  : BOOLEAN;
      Trc : tTrace;
BEGIN
  {* Prfen ob PC/FlexNet geladen bzw. richtige Version vorhanden ist *}
  CASE AX_Init OF
     1   : Write ('PC/FlexNet');
     2   : Write ('PC/FlexNet + FlexDigi');
     ELSE BEGIN
          WriteLn ('--> PC/FlexNet ist nicht geladen oder hat falsche Version! --> Abbruch <--');
          Halt (1)
          END;
     END;
     { Versionsnummernstring holen }
     WriteLn (' V', l2_PVersion, ' gefunden.');

     IF Paramcount>1 THEN
       BEGIN
       WriteLn ('Falsche Anzahl Parameter! --> Abbruch');
       WriteLn ('Aufruf: MoniPCF3 [ <call> ]');
       Halt (2)
       END;
     IF ParamCount=1 THEN sMyCall:=F_Upper(Paramstr(1));
     IF sMyCall='' THEN Writeln (sPgmName,' ist nicht connectbar (es wurde kein Call angegeben)')
                   ELSE Writeln (sPgmName,' ist unter dem Call '+sMyCall+' connectbar');

     FillChar(aQSO, sizeof(aQSO), #0);

     Trc.ch_mask := $FF;{ channes to trace must have 1 in their bit position }
     Trc.typfilter := 0 {TRACETYP_DIAG};
     Trc.trxfilter := 3;{  0: Aus; 1: RX; 2: TX; 3: RX+TX     }
     Trc.call[0] := #0;

     IF l2_chk_monitor THEN l2_clr_monitor;

     Write ('Monitor wird von PCF geholt ... ');
     IF l2_set_monitor (@Trc) THEN Writeln ('ok')
                              ELSE BEGIN
			           Writeln ('Fehler beim Monitor krallen - Abbruch');
                                   Halt(9);
                                   END;

     fPrgEnde := FALSE;
     REPEAT
       IF KeyPressed
         THEN fPrgEnde := DoReadKey(ReadKey)
         ELSE BEGIN
              PollMonitor;
              PollQSO;
              END;
     UNTIL fPrgEnde;

     IF l2_chk_monitor THEN l2_clr_monitor;
END;


BEGIN
  Replay(cNo,'MoniPCF3.RPL');
  WriteStatus;
  SetVersion('Moni-PCFlex', '24.4.96');
  PostInit;
  DoMonitor;
END.
