{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden DOKU.   (C)1989-1996, DG9EP
 -}

UNIT INI;
{$I monisys.inc}

Interface

USES  Crt,Dos,
      portPas,
      {TOOLMoni,} fd_div
      {$IFDEF bp2} ,bsedos {$ENDIF}
      {$IFDEF vp } {$IFDEF PMVersion} ,wincrt {$ENDIF} ,os2base {$ENDIF}
      ;


 TYPE T_IniTab = RECORD
       sName : STRING[40];
       eTyp : (eBOOL,eORD,eSTRING);
       pWert : POINTER;
     END;
     TP_IniTab = ^T_IniTab;


PROCEDURE SchreibeIni( CONST sFileName,sComment:STRING; n:WORD; pini:Tp_IniTab); {eigentlich Array}
PROCEDURE LeseIni( CONST sFileName:STRING;n:WORD; piniOrg:Tp_IniTab); {eigentlich Array}

{--------------------------------------------------------------------------}

IMPLEMENTATION

PROCEDURE SchreibeIni( CONST sFileName, sComment:STRING; n:WORD; pini:Tp_IniTab); {eigentlich Array}
  VAR hdl : Text;
      i,j : WORD;
      pc  : ^Char;
BEGIN {$I-}
  Assign(hdl,sFileName);
  Rewrite(hdl);
  IF IOResult<>0 THEN
    BEGIN
    Writeln;
    Writeln('Kann ',sFileName,' nicht schreiben');
    Exit;;;
    END;
  Writeln(hdl,';-) ',sFileName,' - Automatisch erzeugt am ',
               CurrentDatum,' ',CurrentUhrzeit(0)           );
  Writeln(hdl,';   ',sComment);
  FOR i := 1 TO n DO WITH pIni^ DO
    BEGIN
    Write(hdl,sname,'=');
    IF eTyp = eSTRING THEN
      BEGIN
      pC := pWert; Inc(longint(pc));
      FOR j := 1 TO byte(pWert^) DO
        BEGIN
        Write(hdl, pc^);
        Inc(longint(pc));
        END;
      END
    ELSE IF eTyp=eBOOL THEN
      BEGIN
      IF byte(pWert^)=0 THEN Write(hdl,'false')
                        ELSE Write(hdl,'true');
      END
    ELSE IF eTyp=eORD THEN
      BEGIN
      Write(hdl,byte(pWert^));
      END;
    WriteLn(hdl);
    Flush(hdl); {* Sonst schreibt er anfangs Mll ... !! *}
    Incpn(pointer(pini),sizeof(pini^));  {* Das ist bei BP7 wie in C *}
    IF IOResult<>0 THEN;;;;
    END;
  Close(hdl);
END;



PROCEDURE LeseIni( CONST sFileName:STRING;n:WORD; piniOrg:Tp_IniTab); {eigentlich Array}
  VAR hdl:Text;
      nEq,i,j : WORD;
      pc : ^Char;
      sCmd,sVal,
      sZeile : STRING;
      pini:Tp_IniTab;
BEGIN {$I-}
  Assign(hdl,sFileName);
  Reset(hdl);
  WHILE NOT EOF(hdl) DO
    BEGIN
    ReadLn(hdl, sZeile);
    FOR i := 1 TO length(sZeile) DO
      IF sZeile[i]=';' THEN BEGIN Delete(sZeile,i,255); Break; END
      ELSE IF sZeile[i]<' ' THEN sZeile[i]:=' ';
    sZeile := F_TrimLR(sZeile);
    nEq := Pos('=',sZeile);
    IF neq>1 THEN
      BEGIN
      sCmd := f_Upper(F_TrimLR(Copy(sZeile,1,nEq-1)));
      sVal := Copy(sZeile,nEq+1,255);
      LTrim(sVal);

      pIni := pIniOrg;

      FOR i := 1 TO n DO WITH pIni^ DO
        IF sCmd<>f_Upper(sName)
          THEN Inc(longint(pini),sizeof(t_initab))
          ELSE BEGIN
               IF eTyp=eSTRING THEN
                 BEGIN
                 byte(pWert^) := Length(sVal);
                 pC := pWert; Inc(longint(pc));
                 FOR j := 1 TO Length(sVal) DO
                   BEGIN
                   pc^ := sVal[j];
                   Inc(longint(pc));
                   END;
                 END
               ELSE IF eTyp=eBOOL THEN
                 BEGIN
                 byte(pWert^) := Ord( f_Upper(F_TrimLR(sVal))='TRUE' );
                 END
               ELSE IF eTyp=eORD THEN
                 BEGIN
                 byte(pWert^) := f_Val(f_Upper(F_TrimLR(sVal)));
                 END;
               Break;
               END;
      END;
    END;
  Close(hdl);
END;

END.

