{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden licence.txt.   (C)1989-1996, DG9EP
 -}
Program Kiss2Monitor;
{$I monisys.inc}   {Fr Kompatibilitt zwischen BP, BPct und VP}
{$T-}
{$D AX.25 Lauscher/2 - KISS Version - (c)DG9EP}

{$IFnDEF os2} Nix. Keine Dos Version machbar {$ENDIF}

{$M 18192,8192}

USES dump, monitor, fd_div, toolmoni, mo_def,
     Crt
     {$IFDEF bp2} ,BSEDOS,OS2DEF {$ENDIF}
     {$IFDEF vp } ,os2base,os2def {$ENDIF}
;

TYPE T_LINECONTROL = RECORD
         bDatabits,
         bParity,
         bStopbits{,
         fbTransBreak} : BYTE;
     END;

     T_RXQUEUE = RECORD
         cbChars,cbQueue : USHORT;
     END;


PROCEDURE Main;
  VAR rc      : USHORT;
      hCom    : HFILE;
      action : {$IFDEF BP2} short {$ELSE} Ulong {$ENDIF};
      baudrate : USHORT;
      rLineCtrl : T_LINECONTROL;
      rRXQUEUE : T_RXQUEUE;
      cBuf :  CHAR;
      nBytesRead : ULONG {USHORT};
      fEnde     : BOOLEAN;
      kissbuf,
      aDaten    : T_aDaten;
      xsize : ULONG;
      nDaten : Longint;
      lenkiss   : Word;
      escstate  : Byte;
      strucHeader : t_hheader;
      s,sHeader : STRING;
      sTmp,
      sPort :STRING;
      i,
      nBaudrate : LonGint;

BEGIN
  SetVersion('Moni-KISS/2','9.11.96');
  PostInit;
  Replay(cNo,'MoniKis2.rpl');  {  Replay(False); }

  opt.fAXBodyZeigen :=    TRUE; {* Info Text anzeigen *}
  opt.fDatenBinaer :=     TRUE;
  opt.fSpy         :=     FALsE;
  opt.fBcRx        :=     FALSE;
  opt.fShowAx      :=     TRUE;
  opt.fShowPID     :=     TRUE;
  opt.fSpCompressDecoder := FALSE;

  sPort := 'COM2';
  nBaudrate := 4800;

  FOR i := 1 TO ParamCount DO
    BEGIN
    sTmp := f_Upper(ParamStr(i));
    IF      Copy(sTmp,1,2)='-C' THEN sPort:=           Copy( f_Upper(ParamStr(i)) ,3,255)
    ELSE IF Copy(sTmp,1,2)='-B' THEN nBaudrate:=f_val( Copy( f_Upper(ParamStr(i)) ,3,255) );
    END;

  WriteLn(' Beispiel-Aufruf: MoniKis2 -CCOM1 -B9600');
  WriteLn;
  WriteLn(' Benutzt: Schnittstelle ',sPort,' mit ',nBaudrate,' Baud, N,8,1');

  sPort := sPort+#0;
{$IFDEF BP2}
  rc := DosOpen( @sPort[1], @hCom, @action, 256,
                  FILE_NORMAL, FILE_OPEN,
                  OPEN_ACCESS_READWRITE OR OPEN_SHARE_DENYREADWRITE, 0 ) ;
{$ELSE}
  rc := DosOpen( @sPort[1], hCom,  action, 256,
                  FILE_NORMAL, FILE_OPEN,
                  OPEN_ACCESS_READWRITE OR OPEN_SHARE_DENYREADWRITE, nil ) ;
{$ENDIF}
  IF rc <> 0 THEN
    BEGIN
    WriteLn('Fehler beim ffnen der V24:  rc=', rc);
    Halt(1);
    END;
  WriteLn(' aktueller Aufruf: MoniKis2 -C',sPort,' -B',nBaudrate);

  rlineCtrl.bDatabits    := 8;
  rlineCtrl.bParity      := 0;  {No Parity}
  rlineCtrl.bStopbits    := 0;  { 0 = 1 Stop Bit}
{  rlineCtrl.fbTransBreak := 0; }

{$IFDEF BP2}
{  IF DosDevIOCtl2( nil,0, @rLineCtrl, sizeof(rLineCtrl), $42, $1, hCom )=0 THEN ; {Set Line Charakteristik}
  IF DosDevIOCtl( nil, @rLineCtrl,  $42, $1, hCom )=0 THEN ; {Set Line Charakteristik}
  BaudRate := nBaudrate;
  IF DosDevIOCtl( NiL, @BaudRate, $41, $1, hCom )=0 THEN ;  {Set BitRate}
  IF DosDevIOCtl( @BaudRate, Nil, $61, $1, hCom )=0 THEN ;  {Query BitRate}
  IF DosDevIOCtl( @rRXQUEUE, Nil, $68, $1, hCom )=0 THEN; {* Query number of Charactes in Receive Queue }
{$ELSE}
  xsize := sizeof(rLineCtrl);
  IF DosDevIOCtl( hcom,  $42, $1,
                  @rLineCtrl, xsize, xsize,
                  nil, 0,xsize )=0 THEN ; {Set Line Charakteristik}
  BaudRate := nBaudrate;
  xsize := sizeof(Baudrate);
  IF DosDevIOCtl( hcom,  $41, $1,
                  @Baudrate, xsize, xsize,
                  nil, 0,xsize )=0 THEN ; {Set BitRate }
{  IF DosDevIOCtl( @BaudRate, Nil, $61, $1, hCom )=0 THEN ;  {Query BitRate}
{  IF DosDevIOCtl( @rRXQUEUE, Nil, $68, $1, hCom )=0 THEN; {* Query number of Charactes in Receive Queue }
{$ENDIF}

  {* FirmWare nach KISS umschalten *}
  s := ^x+^x+#27+'@K1'+#$0d;
  IF DosWrite(hCom,s[1],length(s), nBytesRead)=0 THEN ;
  Delay(200);
  { IF DosWrite(hCom,@s[1],length(s), @nBytesRead)=0 THEN ; bp2}
  IF DosWrite(hCom,s[1],length(s), nBytesRead)=0 THEN ;
  Delay(200);

  s := char(FEND)+#$80+char(FEND);  {* SMACK anlocken... *}
  IF DosWrite(hCom,s[1],length(s), nBytesRead)=0 THEN ;
  Delay(200);
  IF DosWrite(hCom,s[1],length(s), nBytesRead)=0 THEN ;
  Delay(200);

  sHeader := ''; lenKiss := 0;
  escstate := 0;
  REPEAT
    rc := DosRead(hCom, cBuf, 1, nBytesRead);
    IF cBuf <> char(FEND)
     THEN BEGIN
          IF cBuf=char(fEsc)
            THEN escstate := fesc
            ELSE IF Escstate=fesc THEN
                   BEGIN
                   Inc(lenKiss);
                   IF      cBuf=char(tfEnd) THEN kissBuf[lenKiss] := char(fend)
                   ELSE IF cBuf=char(tfEsc) THEN kissBuf[lenKiss] := char(fesc);
                   escstate := 0;
                   END
            ELSE BEGIN
                 Inc(lenKiss);
                 IF lenKiss<sizeof(kissbuf) THEN kissBuf[lenKiss] := cbuf;
                 END;
          END
     ELSE IF lenKiss > 1 THEN
            BEGIN {* Frame zu Ende *}
            IF Kiss2Host(@kissbuf[1], lenKiss, sHeader, aDaten, nDaten)
              THEN BEGIN
                   Auswerten( output, sHeader, aDaten, nDaten, strucHeader);
                   END
              ELSE BEGIN
                   SetTextAttr(_red_black);
                   WriteLn('[fehlerhaft] ',sHeader);
                   END;
            lenKiss := 0;
            END;

   fEnde := FALSE;
   IF keyPressed THEN IF DoReadKey(ReadKey) THEN fEnde := TRUE;
 UNTIL fEnde;

 IF DosClose(hCom) = 0 THEN ;
END;

BEGIN
  Main;
END.



