{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden DOKU.  (C)1989-1996, DG9EP
 -}

UNIT Monitor;

{$I monisys.inc}

Interface

USES  Crt,Dos,
      PortPas,
      Dump, fd_div, crc, Ini,
      Mo_Def, Mo_MSpy,
      TOOLMoni,
      Mo_Tool, Mo_Comp,
      BID
      {$IFDEF bp2} ,bsedos {$ENDIF}
      {$IFDEF vp } {$IFDEF PMVersion} ,wincrt {$ENDIF} ,os2base {$ENDIF}
      ;

{CONST effBaud : LongInt = 0;    nBytes :  LongInt = 0;  }

VAR  nPID : ARRAY [0..255] OF LongInt;
     hdlRepl : FILE;

    CONST csWriteSpyTitel = 'Nr. netto/brutto      netto/Brutto/Verlust       ID      Calls';
PROCEDURE WriteSpy( VAR hdl:TEXT);
PROCEDURE WriteOneSpy( VAR hdl:TEXT; i : WORD);
PROCEDURE CloseAllSpy;
PROCEDURE ReplayWriteBuffer(VAR  sHeader : STRING;
                         pDaten  : Pointer;
                         nDaten  : LongInt );
PROCEDURE AusWerten (VAR hdl     : TEXT;
                         sHeader : STRING;
                         aDaten  : t_aDaten;
                         nDaten  : LongInt;
                     VAR strucH  : t_hheader);
 FUNCTION Mem2BCFileHeader ( p:Pointer; memlen : WORD; VAR h:T_BCFileHeader):BOOLEAN;
 FUNCTION WriteFileBFH (CONST sTmpFilename,sServer:STRING;VAR bfh : T_BCFileHeader) : BOOLEAN;
PROCEDURE WriteNPID( VAR hdl:TEXT);

PROCEDURE Replay(f:T_Replay; sFileName:STRING);
 FUNCTION fnReplayCopy : T_Replay;
 FUNCTION IncReplay(x: T_REPLAY): T_REPLAY;

CONST chNULL : CHAR = #0;
      crlf : STRING[2] {ARRAY [1..2] OF CHAR} = #13#10;


{--------------------------------------------------------------------------}

IMPLEMENTATION

  VAR sLocFileName : STRING;
  CONST fCopyReplay  : t_Replay=cNO;


FUNCTION IncReplay( x : T_REPLAY) : T_REPLAY;
BEGIN

  IF x < cFREMD THEN IncReplay := x+1
                ELSE IncReplay := cNO;
END;

PROCEDURE WriteNPID( VAR hdl:TEXT);
  VAR i : WORD;
BEGIN
  FOR i := 0 TO 255 DO
    IF nPid[i] <> 0 THEN Write(hdl,'  ',PID2String(i),':',nPid[i] );
  WriteLn(hdl);
END;


PROCEDURE WriteMem (VAR h:TEXT; p :Pointer; len : WORD; fHtmlConv:BOOLEAN );
  VAR i : WORD;
      c : CHAR;
      s : STRING;
BEGIN
  IF fHtmlConv
    THEN BEGIN
         s := '';
         FOR i := 1 TO len DO
           BEGIN
           AddChar(s, char(p^));
           IF Length(s)>100 THEN
             BEGIN
             Write (h, Str2HTML (s) );
             s := '';
             END;
           Incp1(p);
           END;
         Write (h, Str2HTML (s) );
         END
    ELSE BEGIN
         FOR i := 1 TO len DO
           BEGIN
           Write (h, char(p^) );
           Incp1(p);
           END;
         END
END;


FUNCTION DatenLesbar(p : Pointer; len : WORD) : BOOLEAN;
{* Testet, ob die Daten auf die (p,len) zeigt lesbar oder "binr" sind
 * Wenn in den ersten 20 Zeichen ein Leerzeichen oder ein CR vorkommt
 * gelten die Daten als lesbar
 *}
  VAR i,n : WORD;
BEGIN
  Datenlesbar := TRUE;
{ IF len < 100 THEN Exit;}
  n := 0;
  For i := 1 TO Min(20,len) DO
    BEGIN
    IF (byte(p^)=32) THEN Exit;
    IF (byte(p^)=13) THEN Exit;
    Incp1(p)
    END;
  Datenlesbar := FALSE;
END;




PROCEDURE XorJenTest( p : Pointer; len : WORD;
                 VAR outBuf: t_outbuf; outmaxlen:WORD; VAR reallen:WORD) ;
{* Soll XorJen erkennen und ausgeben. Wenn erkannt dann reallen > 0
 * zurck *}
  VAR i,j : WORD;
      lastchar, c : CHAR;
BEGIN
  Fillchar(outbuf, outmaxlen, #0);
  reallen := 1;
  j:=0;
  for i:=1 TO len Do
     BEGIN
     c := char(p^);
     Incp1(p);
     if (c=#$0a) then continue;
     if (lastchar<>#$9f)
       THEN lastchar:=c
       ELSE BEGIN
            CASE(ord(c) ) of
              $01: c:=#$0a;
              $02: c:=#$0d;
              $03: c:=#$11;
              $04: c:=#$13;
              $40: c:=#$0b;
              $41: c:=#$0c;
              $42: c:=#$0e;
              $43: c:=#$0f;
              $44: c:=#$10;
              $45: c:=#$12;
              $46: c:=#$14;
              $9f: BEGIN
                   c:=#$9f;
                   outBuf[reallen] := char(ord(c) XOR $af);
                   IF reallen < outmaxlen THEN Inc(realLen);
                   END;
              ELSE c:=#$9f;
              END;
            lastchar:=#0;
            END;

     IF (c<>#$9f) THEN
       BEGIN
       outBuf[reallen] := char(ord(c) XOR $af);
       IF reallen < outmaxlen THEN Inc(realLen);
       END;
     END;
  IF (outbuf[1]=Char(FEND)) OR ((outbuf[1]='E') AND (outbuf[2]=#0))
    THEN
    ELSE reallen := 0;
END;


{---------------------------------Spy-------------------------------------}


PROCEDURE InitSpy;
BEGIN
  FillChar (aSpy, sizeof(aspy), #0 );
END;


PROCEDURE WriteOneSpy( VAR hdl:TEXT; i : WORD);
BEGIN
  IF aSpy[i].Id <> 0 THEN
    BEGIN
    WITH aSpy[i].sammler[ord(true)] DO  WriteLn(hdl,
     i:2,
     '. ', nNettoBytes:5, '/',nBruttoBytes:5, ' Byte ',
     ' ',  nNettoPakete:5,'/',nBruttoPakete:5,'/',nLostPakete:5,' Pakete ',
     '  ',aSpy[i].id,
     '  ', aSpy[i].scallFm,
     '',  aSpy[i].scallTo,
     '#'
     );
    WITH aSpy[i].sammler[ord(false)] DO  IF nBruttoPakete > 0 THEN
      BEGIN
      WriteLn(hdl,
      '  ',
      '  ', nNettoBytes:5, '/',nBruttoBytes:5, ' Byte ',
      ' ',  nNettoPakete:5,'/',nBruttoPakete:5,'/',nLostPakete:5,' Pakete '
      );
      END;
    END;
END;


PROCEDURE WriteSpy( VAR hdl:TEXT);
  VAR nLine,i : WORD;
BEGIN
  nLine := 2;
  WriteLn(hdl, csWriteSpyTitel );
  FOR i := 1 TO maxSpy DO
    IF aSpy[i].Id <> 0 THEN
      BEGIN
      Inc(nLine);
      WriteOneSpy(hdl,i);
      IF nLine >= NLINEDATAWINDOW THEN
        BEGIN
        NLine := 2;
        Pausiere('');
        WriteLn(hdl, csWriteSpyTitel );
        END;
      END;
  WriteLn(hdl);
END;


  VAR HdlSpyGlobalFile : Text;
CONST iHdlSpyID : Longint = 0;

FUNCTION GetSpyFile(VAR spy:T_Spy) : TP_TEXT;
BEGIN
  GetSpyFile := nil;
  IF spy.id=0 THEN Halt(33);
  IF spy.id=iHdlSpyID THEN
    BEGIN {* ist per Definiton offen *}
    GetSpyFile := @HdlSpyGlobalFile;
    Exit;
    END;
  IF iHdlSpyID > 0 THEN
    BEGIN {* Alten erst schliessen *}
    Close(HdlSpyGlobalFile);
    IF IOResult=0 THEN;;;
    END;
  Assign(HdlSpyGlobalFile,spy.sFileName);
  Append(HdlSpyGlobalFile);
  IF IOResult<>0 THEN Exit;
  GetSpyFile := @HdlSpyGlobalFile;
  iHdlSpyID := spy.id;
END;

PROCEDURE CloseSpyFile(VAR spy:T_SPY);
BEGIN
  IF spy.id=0 THEN Exit;
  IF (spy.id=iHdlSpyID) AND opt.fQSOSpy THEN
    BEGIN
    Close(HdlSpyGlobalFile);
    IF IOResult = 0 THEN;;;;
    iHdlSpyID := 0;
    END;
END;



PROCEDURE FlushASpy( vonNr{inkl}, bisNr{inkl}:BYTE;
                     VAR spy:T_Spy; richtung:T_Richtung );
{* Buffer eines QSOs leeren & weiterverarbeiten *}
  VAR i : BYTE;
      phFile : TP_Text;
BEGIN
WITH spy.sammler[ord(richtung)] DO
  BEGIN
  i := vonNr;
  REPEAT {* Schreibe buffer[vonnr..bisnr] *}
    WITH aFrame[i] DO
      BEGIN
      IF len = 0
        THEN BEGIN {* Fehlendes Paket *}
             IF fFramesWritten THEN
               BEGIN
               IF opt.fQSOSpy AND spy.fSpyThisQSO THEN
                 BEGIN
                 phFile := GetSpyFile(spy);
                 WriteLn(phFile^);
                 IF Richtung THEN WriteLn(phFile^, '-->??? ',spy.sCallFm,' ???>--')
                             ELSE WriteLn(phFile^, '--<??? ',spy.sCallTo,' ???<--');
                 END;
               Inc(nLostPakete);
               IF spy.pMS <> Nil THEN
                 IF MacheMailspyZeile( spy.pMS^, '',false ) THEN BEGIN END;
               END;
             END
        ELSE BEGIN
             IF opt.fQSOSpy AND spy.fSpyThisQSO THEN
               BEGIN
               phFile := GetSpyFile(spy);
               WriteMem(phFile^, pData, len, opt.fQSOAsHtml );
               END;
             IF spy.pMS <> Nil THEN
               IF MacheMailSpyMem( spy.pms^, pData, len, false) THEN;;
             {* Lsche Buffer*}
             FreeMem(pData,len);
             fFramesWritten := True;
             END;
      pData := nil;
      {crc := 0;}
      len := 0;

      i := (i+1) mod 8;
      END{with};
  UNTIL i=(bisnr+1) mod 8;
  END;
END;


PROCEDURE CloseAllSpy;
  VAR i : BYTE;
BEGIN
  IF opt.fSystemMeldungen AND opt.fQSOSpy THEN WriteSpy(output);
  IF IOResult <> 0 THEN;;;
  FOR i := 1 TO maxSPY DO WITH aSpy[i] DO
    BEGIN {$I-}
    FlushASpy( (sammler[ord(true)].iSupremum  ) Mod 8,
               (sammler[ord(true)].iSupremum+7) mod 8,
               aSpy[i], true);
    FlushASpy( (sammler[ord(false)].iSupremum  ) Mod 8,
               (sammler[ord(false)].iSupremum+7) mod 8,
               aSpy[i], false);
    CloseSpyFile(aspy[i]);
    IF pms <> nil THEN
      BEGIN
      MailspyQuelleClose(pms^);
      FreeMem(pms,sizeof(pms^));
      pms := Nil;
      END;
    aSpy[i].id := 0;
    END;
  nSpy := 0;
  WriteStatus;
END;


{$S-}
FUNCTION OldestSpyClose : WORD;
{* Schliesse einen Spion. Wird auch verwendet wenn zu wenige Handles frei sind *}
  VAR i,oldest : WORD;
      oldTick : Longint;
      phFile : TP_Text;
BEGIN {* nix mehr frei - ltesten Spion suchen *}
   OldestSpyClose := 0;
   oldest := 0;
   oldTick := SysTick;
   FOR i := 1 TO maxSpy DO
     IF (aSpy[i].tickLast < oldTick) AND (aSpy[i].id<>0) THEN
       BEGIN
       oldest := i;
       oldTick := aspy[i].tickLast;
       END;
   IF oldest = 0 THEN Exit;
   WITH aSpy[Oldest] DO
     BEGIN
     FlushASpy( (sammler[ord(true)].iSupremum  ) Mod 8,
                (sammler[ord(true)].iSupremum+7) mod 8,
                 aSpy[oldest], true);
     FlushASpy( (sammler[ord(false)].iSupremum  ) Mod 8,
                (sammler[ord(false)].iSupremum+7) mod 8,
                 aSpy[oldest], false);
     IF opt.fQSOSpy THEN
       BEGIN
       phFile := GetSpyFile(aspy[oldest]);
       WriteLn(phFile^);
       WriteLn(phFile^,
           '= = = = = = = geschlossen '{, strucH.sZeit},'= = = = = = =' );
       CloseSpyFile(aspy[oldest]);
       END;
     IF pMS <> Nil THEN MailspyQuelleClose(pms^);
     IF opt.fSystemMeldungen AND opt.fQSOSpy THEN
       BEGIN
       Flush(pSysHdl^);
       TextAttr := FARBE_SYSTEMMELDUNG;
       WriteLn(pSysHdl^,'Closing spy ',oldest,'', sCallfm,'',sCallto,'');
       END;
     FillChar(aSpy[oldest],sizeof(aSpy[oldest]), #0 );
     Dec(nSpy); WriteStatus;
     END;
   OldestSpyClose := Oldest;
END;


PROCEDURE WriteSpyTOC( iSpy:WORD );
  VAR hdlIDX : Text;
BEGIN
  IF NOT opt.fQSOSpy THEN Exit;

  IF opt.fIdxAsHTML THEN Assign(hdlIdx,sSPYDir+'/SPY_IDX.HTM')
                    ELSE Assign(hdlIdx,sSPYDir+'/SPY_IDX.TXT');
{$i-}
  Reset(hdlIdx);
  IF IOResult = 0
    THEN BEGIN
         Close(hdlIdx);
         Append(HdlIDX);
         END
    ELSE BEGIN {FileNeuanlegen}
         ReWrite(HdlIdx);
         IF opt.fIdxAsHTML THEN WriteLn(hdlIdx,
           '<HTML><head><title>SPY-Index</title></head><BODY>',
           '<a href="../'+sBBSDir+'/mailfrom.htm">Mails von...</a> - ',
           '<a href="../'+sBBSDir+'/Mail_idx.htm">Alle Rubriken...</a>',
           '<h2>QSO-Spy-Index</h2><pre>');
         END;

  WITH aSpy[iSpy] DO
    BEGIN
    IF opt.fIdxAsHTML
      THEN BEGIN
           WriteLn(hdliDx,
              '  <A HREF="',F_liStr(id)+'.htm',{'#HeadEnd}'">',
                 Str2HTML(Str_Using(sCallFm+' <-> '+sCallTo,21)),
                '</A> ',
              ' ', str2html(UnixSec2Str(UnixZeitNow)),
              '  ID:',ID:7
           );
           END
      ELSE BEGIN
           WriteLn(hdliDx,
                    sCallFm:12,
                    sCallto:12,
                    sFilename,
                    '  ID:',ID
                    );
           END;
    IF IOResult= 0 THEN;;;
    Close(hdlIdx);
    IF IOResult= 0 THEN;
    END; {with}
END;


PROCEDURE DoMailAndSpy (CONST strucH: t_hheader; pData:Pointer; len:WORD);
  LABEL l_reset_ag;
  VAR txnr : BYTE;
      inr : ShortInt;
      crcAkt,maxlen,i,
      {resinout,}myIndex,freeIndex : WORD;
      key : Longint;
      fTOCSchreiben,
      fRichtung : BOOLEAN;
      {sFZ,}{sFileName,}s1,s2 : STRING;
      hFile : Text;
      nn : WORD;
BEGIN
  IF NOT opt.fQSOSpy AND NOT opt.fMailSpy THEN Exit;

  {* Fr den Mailspy mssen wir auch QSO-Spy-Technik nutzen *}

  fTOCSchreiben := FALSE;

  IF strucH.sFrame[1]='I'      {* I12^D  oder  UI+ oder .... *}
    THEN txNr := byte( strucH.sFrame[3] )-48
    ELSE BEGIN
         IF strucH.sFrame[1]<>'U' THEN Exit;
         {if strucH.sFrame=Disc' then  close(currentspy); exot }
         txNr := 255; {* Ein UI vermutlich *}
         END;


  {* Hash-ID aus dem Header berechnen *}
  IF strucH.sTo[0] > strucH.sFm[0] THEN maxlen := byte(strucH.sTo[0])
                                   ELSE maxlen := byte(strucH.sFm[0]);
  key :=  0;
  s1 := strucH.sTo;  SetStrLength ( s1, maxlen );
  s2 := strucH.sFm;  SetStrLength ( s2, maxlen );
  FOR i := 1 TO maxlen DO
    BEGIN
    {* Durch die Multiplikation ist die ReihenFolge sTo/sFrom egal *}
    key := key + 128*128*i + ord(s1[i])*ord(s2[i]);
    END;

  {* Spytabelle nach bereinstimmender HashID durchsuchen *}
  i := 1; myIndex := 0; freeIndex := 0;
  REPEAT
    IF key = aSpy[i].ID
      THEN myIndex := i
      ELSE IF (freeIndex=0) AND (aSpy[i].Id=0) THEN freeIndex := i;;;
    Inc(i);
  UNTIL (i>MaxSpy) OR (MyIndex<>0);

  IF MyIndex = 0 THEN
    BEGIN {* Neues QSO -> Neuer Spy *}
    IF freeIndex = 0 THEN
      BEGIN {* Kein Spy mehr frei - ltesten suchen & schliessen  *}
      freeIndex := OldestSpyClose;
      IF freeIndex = 0 THEN Exit;
      END;
    myIndex := freeIndex;

    FillChar(aSpy[Myindex],sizeof(aSpy[Myindex]), #0 );

    {.. Bei Neuanlage ist die Richtung per Def. immer true ..}
    WITH aSpy[MyIndex] DO  WITH sammler[ord(true)] DO
      BEGIN {* Neuanlage Spy *}
      {* Kennzeichen dasser noch nicht init ist (kann erst beim ersten Paket der Gegenrichtung passieren}
      sammler[ord(false)].iSupremum := 255;
      iSupremum := 255;

      IF opt.fQSOSpy THEN
        BEGIN
        IF CheckDirName(sSPYDir) > 99 THEN opt.fQSOSpy := FALSE; {* Ohne Dir kein Spyen *}

        fSpyThisQSO := true;
        IF opt.qsoFilterMode<>cNOSEARCH THEN
          IF ( Pos(opt.sQSOFilter,strucH.sFm) = 0 ) AND
             ( Pos(opt.sQSOFilter,strucH.sTO) = 0 )
             THEN BEGIN {* Nicht vorhanden *}
                  IF opt.qsoFilterMode = cINCL THEN fSpyThisQSO := False;
                  END
             ELSE BEGIN {* vorhanden *}
                  IF opt.qsoFilterMode = cEXCL THEN fSpyThisQSO := False;
                  END;
        END;

      IF  opt.fQSOSpy AND fSpyThisQSO THEN
        BEGIN
        IF opt.fQSOAsHTML
          THEN sFileName := sSpyDir+'/'+F_liStr(key)+'.htm'
          ELSE sFileName := sSpyDir+'\'+F_liStr(key)+'.txt';
        Assign(hFile, sFileName);
  l_reset_ag:
        {$i-}    {* Nachschauen, ob schon vorhanden *}
        Reset(hFile);

        {* Evtl. zu viele Dateien geffnet?}
        IF InOutRes=4 THEN BEGIN
                           IF IOResult = 0 THEN;;;;
                           IF OldestSpyClose>0 THEN Goto l_reset_ag;
                           Exit; {* Fatal ... *}
                           END;

        IF IOResult = 0
          THEN BEGIN {* Es gibt noch einen Mitschrieb einer frheren Sitzung *}
               Close(hFile);
               Append(hFile)
               END
          ELSE BEGIN {* Ganz neu der File *}
               fTOCSchreiben := True;
               Rewrite(hFile);
               IF IOResult <> 0 THEN Exit;
               IF opt.fQSOAsHTML THEN
                 BEGIN
                 WriteLn(hFile, '<html><head><title>QSO: ',
                                strucH.sTo,' --- ', strucH.sFm,
                                '</title></head><body>',
                                '<a href="spy_idx.htm">QSO Spy...</a>',
                                '<h2>', strucH.sTo,' --- ', strucH.sFm,'</h2>',
                                '<pre>'
                                );
                 END;

               {* Header schreiben *}
               Writeln(hFile, csFROM,' ',strucH.sFm);
               Writeln(hFile, csTO,' ',  strucH.sTo);
               Writeln(hFile, 'Date: ',  strucH.sZeit);
               Writeln(hFile, 'X-Spy: ', sPgmName,' ',sPgmVersion, ' ',csPLATTFORM);
               Writeln(hFile);
               IF opt.fQSOAsHTML THEN
                 BEGIN
                 WriteLn(hFile, '<a name="textstart"><hr></a>');
                 END;
               END;
        IF IOResult <> 0 THEN Exit;
        WriteLn(hFile); WriteLn(hFile);
        WriteLn(hFile, '======== ',strucH.sFm,'',strucH.sTo,
                       ' (',strucH.sVia,') - ', strucH.sZeit,' ========' );
        WriteLn(hFile);
        END;

      {* Wir sind noch immer in der Neuanlage Spy *}
      id := key; {* Sicherheitshalber nochmal *}
      GetMem(pms, sizeof(pms^) );
      MailspyQuelleOpen( pms^, strucH.sFm, strucH.sTo );

      sCallFm:= strucH.sFm;
      sCallTo:= strucH.sTo;
     {RTrimCtrl(sCalls); }{* VP hat da wohl manchmal Schwierigkeiten *}
      nNettoBytes := 0;      nNettoPakete := 0;
      nBruttoBytes := 0;     nBruttoPakete := 0;

      IF fTOCSchreiben THEN WriteSpyTOC( myIndex );
      IF opt.fSystemMeldungen AND opt.fQSOSpy THEN
        BEGIN
        Flush(pSysHdl^);
        TextAttr := FARBE_SYSTEMMELDUNG;
        WriteLn(pSysHdl^,'Open spy ',MyIndex,'',sCallfm,'',sCallto,'');
        END;
      Inc(nSpy);
      WriteStatus;
      IF fSpyThisQSO THEN Close (hFile); {* Die Daten rauschen erstmal nur durch den Sammler *}
      IF IOResult <> 0 THEN ;;;;
      END; {with}
    END; {neuer Spy}

  globalLastSpyIndex := MyIndex;
  WITH aSpy[MyIndex] DO
    BEGIN
    {* Jetzt braucht man auch die Richtung des QSOs... *}
    fRichtung := sCallFm = strucH.sFm;

    WITH sammler[ord(fRichtung)] DO
      BEGIN
      IF iSupremum > 8 THEN
        IF Txnr = 255
          THEN iSupremum := 4 {* Sonderfall UI }
          ELSE iSupremum := (txnr+7) mod 8; {* Anfang wilkrlich auf 1 Frames vor dem ersten RX festlegen*}

      Inc(nBruttoBytes,len);
      Inc(nBruttoPakete);
      IF txnr = 255 THEN
         txnr := (iSupremum+1) Mod 8; {* Sonderbehandlung UI *}
      tickLast := SysTick; {* das ist ein Lebenszeichen -> merken *}

      {* So und nun gugen, ob Reihenfolge stimmt *}
      {* Ist es vielleicht nur ne Framewiederholung? *}
      crcAkt := Calc_CRCFBB( $5aa5, pData, len);
      IF (crcAkt = aFrame[txnr].crc) THEN Exit; {* Dasselbe Frame hammer schon, vergiss es *}
      IF (aFrame[txnr].len = 0)
        THEN BEGIN
             {* Nix besonderes notwendig, wird unten ganz normal eingefgt *}
             END
        ELSE BEGIN {* Anderes Frame mit selber Nummer *}
             iNr := txnr;
             iSupremum := iNr;
             nn:= 0;
             WHILE (aFrame[inr].len>0) AND (nn<8){(inr<>(txnr+7) MOD 8)}DO
               BEGIN
               iSupremum := iNr;
               inr := (inr+1) mod 8;
               inc(nn);
               END;
             FlushASpy(txnr, isupremum, aSpy[MyIndex], fRichtung );
             END;
      Inc(nNettoBytes, len);
      Inc(nNettoPakete);
      {* setze pData nach buffer[txnr] *}
      aFrame[txnr].crc := crcAkt;
      aFrame[txnr].len := len;
      GetMem(aFrame[txNr].pData, aFrame[txnr].len);
      Move(pData^, aFrame[txNr].pData^, len );
      END; {With}
    END; {With}
END;

{---------------------------- Broadcast (BC) -------------------------------}


CONST cMAXBCWORK = 3;
VAR {initDat : ARRAY [1..700] OF BYTE;  }
    aBC : ARRAY [1..cMAXBCWORK] OF T_BCWork;
{    BcWorkvorher : T_BCWork; }


FUNCTION Mem2BCFileHeader ( p : Pointer; memlen : WORD;
                        VAR h : T_BCFileHeader) : BOOLEAN;
{* Wandelt die Informationen aus dem binren FileHeader um in die Struktur.
 * p zeigt dabei auf den Anfang des FileHeaders (ohne Frameheader z.B)
 *}
  TYPE T_Cv = ARRAY [1..500] OF CHAR;
  VAR pHead : ^T_Cv;
      headCHeckSum : WORD;
      id, n,npos : WORD;
      len  : BYTE;
      fEndHeader : BOOLEAN;
BEGIN
  Mem2BCFileHeader := FALSE;
  pHead := p;
  FillChar(h,sizeof(h),#0);
  n := 3;
  IF (pHead^[1] <> #$aa) OR (pHead^[2] <> #$55) THEN
    BEGIN {* evtl. neue Variante, 2 TimeStamps vorneweg *}
    IF (pHead^[9] <> #$aa) OR (pHead^[10] <> #$55) THEN Exit;
    n := 11;
    END;
  fEndHeader := FALSE;
  WHILE (n<=memLen) AND NOT fEndHeader DO
    BEGIN
    id :=  ord(pHead^[n])+256*ord(pHead^[n+1]);
    len := ord(pHead^[n+2]);
    Inc(n,3);
    CASE ID of
      $00 : fEndHeader := TRUE;
      $01 : Move(pHead^[n],   h.fid,   len);  {fileid}
      $02 : Move(pHead^[n-1], h.sFileName[0], len+1); { pcs+ tnn-? }
      $03 : Move(pHead^[n-1], h.sFileExt [0], len+1); { pcs+ tnn-? }
      $04 : Move(pHead^[n],   h.filen, len);  {filesize longint +pcf}
      $05 : Move(pHead^[n],   h.createTime, len); {create-time, unix. +TNN +pcf}
      $06 : Move(pHead^[n],   h.lastModTime, len); {last_modified_time, -TNN +pcf}
      {7 SeuFlag : pcs+}
      $08 : Move(pHead^[n],   h.fileType, sizeof(h.fileType)); {TNN=0 +pcf}
      $09 : Move(pHead^[n],   h.bodyCHeckSum, sizeOf(h.bodyCHeckSum) );
      $0a : Move(pHead^[n],   headCHeckSum, sizeOf(headCHeckSum) );
      $0b : Move(pHead^[n],   h.bodyOffset, len);
      $10 : Move(pHead^[n-1], h.sAbsender[0], len+1); {absender}
      $11 : Move(pHead^[n-1], h.sUploader[0], len+1); {TNN: MyCall des Digis}
      $12 : Move(pHead^[n],   h.uploadTime, len); {uploadtime TNN+, pcs+}
      $13 : Move(pHead^[n],   h.bDownloadcount, sizeof(h.bDownloadcount) ); {download_count TNN+ pcs+ }
      $14 : Move(pHead^[n-1], h.sRubrik   [0], len+1); {rubrik  }
      $15 : Move(pHead^[n-1], h.sDownLoader[0], len+1); {ax25_downloader TNN+ (leer)}
      $16 : Move(pHead^[n],   h.downloadTime, len);
      $17 : Move(pHead^[n],   h.expTime, len);
{     $18 priority              1b   pcs+ tnn+
      $19 compression_type      1b   pcs- tnn+
 }
      $20 : Move(pHead^[n],   h.chBBSMsgTyp  , sizeof(h.chBBSMsgTyp) ); {pcs+ tnn-; b ODER p}
      $21 : Move(pHead^[n-1], h.sBID     [0], len+1);
      $22 : Move(pHead^[n-1], h.sTitle   [0], len+1);
      $23 : Move(pHead^[n-1], h.sKeywords[0], len+1); {* KeyWords pcs+ tnn-*}

      $FFFF : n := memlen;
      END;{case}
    Inc(n,len);
    END;

  IF h.sTitle[ length(h.sTitle) ] = #13 THEN h.sTitle[ length(h.sTitle) ] := ' ';
  nPos := Pos(' @',h.sRubrik);
  IF nPos > 0 THEN
    BEGIN  {* TNN,DP,PCS als Server *}
    h.sVerteil := Copy( h.sRubrik, nPos+2,255);
    Delete(h.sRubrik, nPos,255);
    END;
  IF h.sVerteil = '' THEN h.sVerteil := h.skeywords;

  Mem2BCFileHeader := fEndHeader; {* nur True, wenn Ende des FileHeaders erreicht *}
END;


 VAR Buf: array[1..2048] of Char;

PROCEDURE ClearBCWork( vAR X:T_BCWork);
BEGIN
  FillChar(x,sizeof(x),#0);
END;


PROCEDURE WriteIntoMetaIndex(CONST sText : STRING);
  VAR hdlIdx : TEXT;
BEGIN
  IF opt.fIdxAsHTML THEN Assign(hdlIdx,sBBSDir+'\MAIL_IDX.HTM')
                    ELSE Assign(hdlIdx,sBBSDir+'\MAIL_IDX.TXT');
  Reset(hdlIdx);
  IF IOResult = 0
      THEN BEGIN
           Close(hdlIdx);
           Append(HdlIDX);
           END
      ELSE BEGIN {* File neuanlegen *}
           ReWrite(HdlIdx);
           IF opt.fIdxAsHTML THEN
             WriteLn(hdlIdx,
              '<HTML><head><title>Alle Rubriken</title></head><BODY>',
              '<a href="mailfrom.htm">Mails von...</a> - <a href="../',sSPYDir,'/SPY_IDX.HTM">QSO Spy...</a>',
              '<h2>Alle Rubriken</h2>');
           END;

  WriteLn(hdliDx, sText );
  IF IOResult= 0 THEN;;;;;
  Close(hdlIdx);
  IF IOResult= 0 THEN;
END;

PROCEDURE WriteIntoMailFromIndex(CONST sText : STRING);
  VAR hdlIdx : TEXT;
BEGIN
  IF opt.fIdxAsHTML THEN Assign(hdlIdx,sBBSDir+'\MAILFrom.HTM')
                    ELSE Assign(hdlIdx,sBBSDir+'\MAILFrom.TXT');
  Reset(hdlIdx);
  IF IOResult = 0
      THEN BEGIN
           Close(hdlIdx);
           Append(HdlIDX);
           END
      ELSE BEGIN {* File neuanlegen *}
           ReWrite(HdlIdx);
           IF opt.fIdxAsHTML THEN
             WriteLn(hdlIdx,
              '<HTML><head><title>Mails von ...</title></head><BODY>',
              '<a href="Mail_idx.htm">Alle Rubriken...</a> - <a href="../',sSPYDir,'/SPY_IDX.HTM">QSO Spy...</a>',
              '<h2>Mails von ...</h2>');
           END;
  WriteLn(hdliDx, sText);
  IF IOResult= 0 THEN;
  Close(hdlIdx);
  IF IOResult= 0 THEN;
END;


FUNCTION WriteFileBFH (CONST sTmpFilename,sServer:STRING;
                       VAR bfh : T_BCFileHeader) : BOOLEAN;
{* in sTmpFilename steht ein Dateiname *}
  CONST csPreKey='<b>';
        csPstKey='</b>';
  VAR j      : WORD;
      sFN, sTmp,
      s,sUp : STRING;
      sExt : STRING[10];
      rBID : T_BID;
      hdlIdx : TEXT;
      hdlSrc,hdlDest : FILE;
      hdlWrk : FILE {$IFDEF TypedFile} OF T_BCWORK {$ENDIF} ;
      NumRead { , NumWritten}  : LInteger;
BEGIN
  WriteFileBFH := true;
  Assign(hdlSrc, sTmpFilename+cEXTDATA);
  IF bfh.sBID >'   ' THEN
    BEGIN
    IF SearchBID(f_Upper(bfh.sBID),rBID) THEN
      BEGIN {* Den haben wir schon; tmp.Data lschen *}
      WriteFileBFH := false;
      Erase(hdlSrc);
      IF IOResult <> 0 THEN;;; {Pausiere(' Fehlerchen beim temp.Dateilschen')};

      Assign(hdlSrc, sTmpFilename+cEXTWORK);
      Erase(hdlSrc);
      IF IOResult = 0 THEN;;;
      Exit;
      END;
    END;

  InsertBID(f_Upper(bfh.sBID),cNOCHECK);
  {bfh.sUsedFileName := sFileName;}

  Assign(hdlDest, sTmpFilename+'.$$$');
  Rewrite(hdlDest,1);


  IF opt.fMailAsHTML
    THEN BEGIN
         s := '<HTML><head><title>' + bfh.sTitle  + '</title></head>'
            + '<body> <center>'+#13#10
            + '<a href="../' + bfh.sRubrik  + '/index.htm">Rubrik ' + bfh.sRubrik + '</a> '
            + '<a name="Oben">-</a> '
            + '<A HREF="../MAIL_IDX.HTM">Alle Rubriken...</A> - '
            + '<a href="../mailfrom.htm">Mails von...</a>';
         BlockWrite(hdlDest, s[1], length(s));
         s := '</center><hr><pre>'+#13#10
            + csSUBJECT + ' <a href="#textstart">' + csPreKey + bfh.sTitle + csPstKey +'</a>'#13#10
            + csFROM    + ' <a href="../'+f_trim(bfh.sAbsender)+'.htm">' + csPreKey + bfh.sAbsender + csPstKey + +'</a>'#13#10
            + '<font size=-1>'#13#10;
         END
    ELSE s := csSUBJECT+' '+ bfh.sTitle    + #13#10
            + csFROM   +' '+ bfh.sAbsender + #13#10;
  BlockWrite(hdlDest, s[1], length(s));

  sUp := F_TrimLR(bfh.sUpLoader);
  bfh.sDownLoader := F_TrimLR(bfh.sDownLoader);
  IF (sUp <> '') OR (bfh.sDownloader<>'') THEN
      BEGIN
      s := 'Path: ' +     +       sServer
                    + '!' + bfh.sDownloader
                    + '!' + sUp
                    + '!...!'
                    + F_TrimLR(bfh.sAbsender)
                    + #13#10;
      BlockWrite(hdlDest, s[1], length(s));
      END;

  IF F_Trim(bfh.sBID)<>''
      THEN s:= 'Newsgroup: ampr.bbs.'+ F_Lower(bfh.sRubrik)     + #13#10
             + 'Distribution: '      + F_TrimLR(bfh.sVerteil)   + #13#10
             + 'Message-ID: '       + '<'+bfh.sBID+'@bbs.net>'  + #13#10
      ELSE s:=  csTo + ' ' + F_Lower(bfh.sRubrik) + #13#10;
  s := s + 'Date: '+UnixSec2Str(bfh.createTime) + #13#10;
  IF F_Trim(bfh.sKeywords)<>'' THEN
        s := s + 'Keywords: ' + F_TrimLR(bfh.sKeywords) + #13#10;
    BlockWrite(hdlDest, s[1], length(s));

    s := 'X-Length: ' + F_liStr(bfh.filen)+' Bytes '+#13#10;
    IF bfh.LastModTime    > 0 THEN s := s + 'X-Last-Mod: '   + UnixSec2Str(bfh.LastModTime ) + #13#10;
    IF bfh.upLoadTime     > 0 THEN s := s + 'X-Uploadt.: '   + UnixSec2Str(bfh.uploadTime  ) + #13#10;
    IF bfh.downloadTime   > 0 THEN s := s + 'X-Download: '   + UnixSec2Str(bfh.downloadTime) + #13#10;
    IF bfh.expTime        > 0 THEN s := s + 'X-Lifetime: '   + UnixSec2Str(bfh.expTime     ) + #13#10;
    IF bfh.bdownloadCount > 0 THEN s := s + 'X-Downloadcount: '+ F_LiStr(bfh.bdownloadCount)+#13#10;
    IF bfh.chBBSMsgTyp  > ' ' THEN s := s + 'X-BBS-Msg-Type: ' + bfh.chBBSMsgTyp +#13#10;
    BlockWrite(hdlDest, s[1], length(s));

    s:='';
    IF F_Trim(bfh.sBID)<>'' THEN s := s + csAX25BBSBID+ ' ' + bfh.sBID +#13#10;
    IF bfh.fid>0 THEN s := s
                   + 'X-BBS-BC-FID: '      + f_lisTr(bfh.fid)+'@'+sUp+#13#10
                   + 'X-BBS-BC-Filetype: ' + F_Str(bfh.fileType) +#13#10;
                  {+ 'X-Comment: <A Name="HeadEnd">x</A>'+ #13#10}
    s := s + 'X-RX-Program: ' + sPgmName+' '+sPgmVersion + ' ' +csPLATTFORM
           + #13#10
           + #13#10; {* Leerzeile, danach kommt Body *}
    IF opt.fMailAsHTML THEN s := s+'</font><a name="textstart"><hr></a>'#13#10;

    BlockWrite(hdlDest, s[1], length(s));
    IF IOResult=0 THEN;;

    {* Und nun den rest kopieren *}
    Reset(hdlSrc,1);
    IF IOResult=0 THEN;;
    Seek(hdlsrc,bfh.bodyoffset);
    IF IOResult=0 THEN;;
    REPEAT
      BlockRead ( hdlSrc,  Buf, SizeOf(Buf), NumRead    );
      BlockWrite( hdlDest, Buf, NumRead{,     NumWritten} );
    UNTIL (NumRead = 0) {or (NumWritten <> NumRead) $TODO };

    IF opt.fMailAsHTML THEN
      BEGIN
      s := '</pre><hr><center> <a href="#Oben">Anfang der Seite</a> - '
         + '<a href="../' + bfh.sRubrik + '/index.htm">Rubrik ' + bfh.sRubrik + '</a> - '
         + '<A HREF="../MAIL_IDX.HTM">Alle Rubriken...</A> - '
         + '<a href="../mailfrom.htm">Mails von...</a>'
         + '</center><p></body></html>';
      BlockWrite(hdlDest, s[1], length(s));
      IF IOResult=0 THEN;;
      END;

    Close(hdlSrc);  IF IOResult=0 THEN;;
    Close(hdlDest); IF IOResult=0 THEN;;

    IF CheckDirName(sBBSDir) > 99 THEN;;;;

    bfh.iUsedRubrikNr := 0;
    IF opt.fMailAsHTML THEN sExt := '.htm'
                       ELSE sExt := '.txt';
    REPEAT
      Inc(bfh.iUsedRubrikNr);
      bfh.sUsedBasename := Copy(Copy(bfh.sBid,1,7)+f_lisTr(bfh.iUsedRubrikNr),1,8)+sExt;
      IF CheckDirName(sBBSDir+'\'+bfh.sRubrik) > 99 THEN ;;;;
      FOR j := 1 TO length(bfh.sUsedBasename) DO
        IF bfh.sUsedBasename[j] = '+' THEN bfh.sUsedBasename[j] := 'X';
      Rename(hdlDest, sBBSDir+'\'+bfh.sRubrik+'\'+bfh.sUsedBaseName);
    UNTIL (IOResult=0) OR (bfh.iUsedRubrikNr>500);
    IF bfh.iUsedRubrikNr>500 THEN bfh.sUsedBaseName := '';
    IF IOResult=0 THEN;;

    {* So, nun noch den Wrk-Filelschen, falsch vorhanden *}
    Assign(hdlWrk, sTmpFilename+cEXTWORK);
    Erase(hdlWrk);
    IF IOResult=0 THEN;;
    Assign(hdlWrk, sTmpFilename+cEXTDATA);
    Erase(hdlWrk);
    IF IOResult=0 THEN;;

  {*------------------- BC - Inhaltsverzeichnis schreiben ----------------------*}
  {* Erst die Rubrik *}
  Trim(bfh.sRubrik);
  IF opt.fIdxAsHTML
    THEN sFn := bfh.sRubrik+'/INDEX.HTM'
    ELSE sFn := bfh.sRubrik+'/INDEX.TXT';
  Assign(hdlIdx,sBBSDir+'\'+sFN);
  Reset(hdlIdx);
  IF IOResult = 0
    THEN BEGIN
         Close(hdlIdx);
         Append(HdlIDX);
         END
    ELSE BEGIN {* File neu anlegen *}
         ReWrite(HdlIdx);
         IF opt.fIdxAsHTML
           THEN BEGIN
                sTmp := 'Rubrik '+bfh.sRubrik;
                WriteLn(hdlIdx,'<HTML><head><title>',sTmp,'</title></head><BODY>',
                               '<A HREF="../MAIL_IDX.HTM">Alle Rubriken...</A> - ',
                               '<a href="../mailfrom.htm">Mails von...</a>',
                               '<h2>',stmp,'</h2><pre>'
                );
                WriteIntoMetaIndex('*** <A HREF="'+sFN+'">'+Str2HTML(bfh.sRubrik)+'</A>  ');
                END
           ELSE WriteIntoMetaIndex('*** '+bfh.sRubrik+' ... '+sFN);
         END;
  WriteBCIndexLine( hdlIDX, bfh, bfh.sUsedBaseName,'../',opt.fIdxAsHTML);
  IF IOResult= 0 THEN;;;;;
  Close(hdlIdx);
  IF IOResult= 0 THEN;

  {*** Tageslisten ****}
  IF opt.fIdxAsHTML
    THEN sFn := CurrentDatumAsFilename+'.htm'
    ELSE sFn := CurrentDatumAsFilename+'.Txt';
  Assign(hdlIdx,sBBSDir+'\'+sFN);
  Reset(hdlIdx);
  IF IOResult = 0
    THEN BEGIN
         Close(hdlIdx);
         Append(HdlIDX);
         END
    ELSE BEGIN {* File (TagesIndex) neu anlegen *}
         ReWrite(HdlIdx);
         IF opt.fIdxAsHTML
           THEN BEGIN
                sTmp := 'Mails vom '+Str2HTML(CurrentDatum);
                WriteLn(hdlIdx,
                   '<HTML><head><title>',sTmp, '</title></head><BODY>',
                   '<A HREF="MAIL_IDX.HTM">Alle Rubriken...</A> - ',
                   '<a href="mailfrom.htm">Mails von...</a>',
                   '<h2>',sTmp,'</h2><pre>');
                WriteIntoMetaIndex('*** <A HREF="'+sFN+'">'+Str2HTML(CurrentDatum)+'</A>  ');
                END
           ELSE WriteIntoMetaIndex('*** '+CurrentDatum+' ... '+sFN);
         END;
  WriteBCIndexLine( hdlIDX, bfh, bfh.sRubrik+'/'+bfh.sUsedBaseName, '', opt.fIdxAsHTML);
  IF IOResult= 0 THEN;;;;;
  Close(hdlIdx);
  IF IOResult= 0 THEN;

  {* Callisten *}
  IF opt.fIdxAsHTML
    THEN sFn := f_trim(bfh.sAbsender) + '.htm'
    ELSE sFn := f_trim(bfh.sAbsender) + '.Txt';
  Assign(hdlIdx,sBBSDir+'\'+sFN);
  Reset(hdlIdx);
  IF IOResult = 0
    THEN BEGIN
         Close(hdlIdx);
         Append(HdlIDX);
         END
    ELSE BEGIN {* File (CallIndex) neu anlegen *}
         ReWrite(HdlIdx);
         IF opt.fIdxAsHTML
           THEN BEGIN
                sTmp := 'Mail von '+Str2HTML(bfh.sAbsender);
                WriteLn(hdlIdx,'<HTML><head><title>',sTmp,
                        '</title></head><A HREF="MAIL_IDX.HTM">Alle Rubriken...</A> - ',
                        '<a href="',f_trim(bfh.sAbsender),'">Mail f&uuml;r ',
                        Str2HTML(bfh.sAbsender),'</a><BODY><h2>',sTmp,
                        '</h2><pre>');
                WriteIntoMailFromIndex('*** <A HREF="'+sFN+'">'+Str2HTML(bfh.sAbsender)+'</A>  ');
                END
           ELSE WriteIntoMailFromIndex('*** '+bfh.sAbsender+' ... '+sFN);
         END;
  WriteBCIndexLine( hdlIDX, bfh, bfh.sRubrik+'/'+bfh.sUsedBaseName, '', opt.fIdxAsHTML);
  IF IOResult= 0 THEN;;;;;
  Close(hdlIdx);
  IF IOResult= 0 THEN;

  WriteStatus;
END;



FUNCTION DoBCFile( iBC : WORD ) : BOOLEAN;
{* Versuche den Broadcast-File auf Platte abzuschliessen *}
  VAR headSize : LINTEGER;
      head : Array[1..500] OF CHAR;
      bfh : T_BCFileHeader;
      hdlSrc : FILE;
BEGIN{$R+}{$Q+}
  DoBCFile := false;
  With aBC[iBC] DO
    BEGIN
    IF nFragList <> 1 THEN Exit; {* nicht komplett *}
    IF fragList[1][cVON] <> 0 THEN Exit; {* Anfang fehlt *}

    Assign(hdlSrc, sFilename+cEXTDATA);
    Reset(hdlSrc,1);
    BlockRead(hdlSrc,head[1],sizeof(head),headSize);
    Close(hdlSrc);
    IF IOResult <> 0 THEN Exit;

    IF NOT Mem2BCFileHeader( @head, headSize, bfh ) THEN Exit;
    IF fragList[1][cBIS]+1 < bfh.fiLen THEN Exit;
    {bfh.bodyoffset}
    DoBCFile := true;
    IF WriteFileBFH (sFileName,sServer,bfh) THEN
      BEGIN
      Inc(nBCFilesRx);
      WriteStatus;
      END;
    {* so, und ArbeitsStruktur wieder als frei kennzeichenne *}
    ClearBCWork(aBC[iBc]);
    END;
END;




PROCEDURE SchliesseUnfertige(ibc : Word);
  VAR hdlWrk : FILE {$IFDEF TypedFile} OF T_BCWORK{$ENDIF};
BEGIN
With aBC[iBC] DO
  BEGIN
  IF id = 0 THEN Exit;
  IF DoBCFile(iBC) THEN Exit; {* War wohl doch ok *}
  Assign(hdlWrk, sFilename+cEXTWORK);
  ReWrite(hdlWrk{$IFnDEF TypedFile},1{$ENDIF});
  IF IOResult= 0 THEN;;;;;
{$IFDEF TypedFile}
  Write(hdlWrk,aBC[iBC]);
{$ELSE}
  BlockWrite(hdlWrk, aBC[iBC], sizeof(aBC[iBC]) );
{$ENDIF}
  IF IOResult= 0 THEN;;;;;
  Close(hdlWrk);
  IF IOResult= 0 THEN;;;;;
  ClearBCWork(aBC[iBc]);
  END;
END;


FUNCTION HoleBCWork(paraid : Longint):WORD;
  VAR iBC : WORD;
      hdlBC : FILE;
      hdlWrk : FILE {$IFDEF TypedFile}OF T_BCWORK{$ENDIF};
BEGIN
  HoleBCWork := 0;
  {$i-}
  FOR iBC := 1 TO cMAXBCWORK DO
    IF aBC[iBC].id = paraid
      THEN BEGIN
           HoleBCWork := iBC;
           Exit;
           END;
  {*  Nicht gefunden: Neuen allokieren.  *}
  {* Freien suchen *}
  FOR iBC := 1 TO cMAXBCWORK DO
    IF aBC[iBC].id = 0 THEN Break;

  IF iBC>=cMAXBCWORK THEN
    BEGIN {*einen alten rausschmeissen*}
    iBC := random(cMAXBCWORK)+1;
    SchliesseUnfertige(iBC);
    END;

  With aBC[iBC] DO
    BEGIN
    ID := paraid;
    sfilename := sBBSDir+'\'
               { +HostHead.sFm+'\' }
                 +HexLIString(id);

    IF CheckDirName(sBBSDir) > 99 THEN
      BEGIN
      opt.fBCRx := FALSE; {* Ohne Dir kein BC! *}
      Exit;
      END;

    Assign(hdlBC, sFilename+cEXTDATA);
    {$i-}
    Reset(hdlBC,1);
    IF IOResult <> 0
      THEN BEGIN {* aha! Ein ganz neuer File ... *}
           Rewrite(hdlBC,1);
           IF IOResult <> 0 THEN ;;;;
           {BlockWrite( hdlBC, InitDat, sizeof(InitDat));
           IF IOResult <> 0 THEN ;;;;}
           END
      ELSE BEGIN { Anderer File, der aber wohl schon besteht }
           {* Dann saugen wir uns mal seine .wrk File}
           Assign(hdlWrk, sFilename+cEXTWORK);
           Reset( hdlWrk {$IFnDEF TypedFile}, 1 {$ENDIF} );
           FillChar(aBC[iBC],sizeof(aBC[1]),#0);
           IF IOResult=0 THEN
             BEGIN
{$IFDEF TypedFile}
             Read(hdlwrk,aBC[iBC]);
{$ELSE}
             BlockRead(hdlWrk, abc[ibc], sizeof(T_BCWORK) );
{$ENDIF}
             END;
           IF IOResult=0 THEN ;;;
           Close(hdlWrk);
           IF IOResult=0 THEN ;;;
           END;
    Close(hdlBC);
    IF IOResult<>0 THEN;;;
    END;
  HoleBCWork := iBC;
END;


PROCEDURE EvtlVerschmelzen( VAR x :T_BCWork; a,b:Integer );
BEGIN
WITH x DO
  BEGIN
  IF nFragList >= b THEN
   IF a>0 THEN
    IF FragList[a][cBIS]+1 = FragList[b][cVON] THEN
        BEGIN { a und b verschmelzen }
        FragList[a][cBIS] := FragList[b][cBIS];
        IF nFragList >= b+1 THEN
          Move( FragList[b+1],FragList[b], (nFragList-b)*sizeof(FragList[1]) );
        Dec(nFragList);
        END;
   END;
END;

PROCEDURE BC2Work ( CONST hostHead:t_hheader;
                     p1 : pointer; len : WORD  );
{* Verarbeite die Daten im BroadcastFrame (hostheader;p1;len) *}
  VAR p : ^t_bcFrame;
      iBC, i : Longint;
      hdlBC  : FILE;
BEGIN {$R-}
  p := p1; {* Konvertieren zur Compilerberlistung *}
  IF Calc_CRCFBB( 0, p1, len) <> 0 THEN
    BEGIN
    Exit;
    END;
  Inc(nBCPaketeRx);
  iBC := HoleBCWork(p^.h.fileid);

  WITH aBC[iBC] DO
    BEGIN
    Assign(hdlBC, sFilename+cEXTDATA);
    Reset(hdlBC,1);
    IF IOResult <> 0 THEN Exit;
    offset := longint(p^.h.offset)+65536*p^.h.offsetH;
    flast  := (p^.h.flag AND $20) <> 0;
    sServer := hosthead.sFm;
    {* Daten kopieren *}
    partlen := longint(len)-2-sizeof(p^.h);

    IF offset=0 THEN
      BEGIN
      offset := offset;
      END;

    IF nFragList = 0
      THEN BEGIN
           Inc(nFragList);
           i := nFragList;
           FragList[i][cVON] := offset;
           FragList[i][cBIS] := offset+partlen-1;
           END
      ELSE BEGIN
           FOR i := 1 TO nFragList DO
             BEGIN
             IF (FragList[i][cBIS]+1 = offset) THEN
                BEGIN {* Verschmelzung von oben *}
                FragList[i][cBIS] := offset+partlen-1;
                {* test ob nchster mit verschmelzt werden muss *}
                EvtlVerschmelzen(aBC[iBC], i, i+1);
                Break;
                END
             ELSE IF FragList[i][cVON] = offset+partlen THEN
                BEGIN {* Verschmelzung von unten *}
                FragList[i][cVON] := offset;
                EvtlVerschmelzen(aBC[iBC], i-1, i);
                Break;
                EnD
             ELSE IF FragList[i][cVON] > offset+partlen THEN
                BEGIN {einen Platz frei machen, falls mglich }
                IF nFragList < cMAXFRAG THEN
                  BEGIN
                  Move( FragList[i],FragList[i+1], sizeof(FragList[1]) );
                  FragList[i][cVON] := offset;
                  FragList[i][cBIS] := offset+partlen-1;
                  Inc(nFragList);
                  END;
                BREAK;
                END;
             END;
           END;

    Seek(hdlBC, offset);                  IF IOResult <> 0 THEN ;;;;
    BlockWrite(hdlBC, p^.data, partlen);  IF IOResult <> 0 THEN ;;;;
    Close(hdlBC);                         IF IOResult <> 0 THEN ;;;;

    IF fLast OR ((nFragList=1) AND (FragList[1,cVON] = 0)) THEN
      BEGIN
      IF DoBCFile( iBC ) THEN ;;;;;
      END;
    END; {With}
END; {* Bc *}


{$i+}

{-------------------------------------------------------------------------}

PROCEDURE ReplayWriteBuffer(VAR  sHeader : STRING;
                         pDaten  : Pointer;
                         nDaten  : LongInt );
BEGIN
  BlockWrite( hdlRepl, sHeader, length(sHeader)+1 );
  BlockWrite( hdlRepl, nDaten, sizeof(nDaten));
  BlockWrite( hdlRepl, pDaten^, nDaten);
END;



PROCEDURE AusWerten (VAR hdl     : TEXT;
                         sHeader : STRING;
                         aDaten  : t_aDaten;  nDaten  : LongInt;
                     VAR strucH  : t_hheader);
VAR {outbuf    : t_outbuf;}
    {ib,} oblen : Word;
    sAx25Head : String;
    fLocDone,
    fShow     : BOOLEAN;
    {int       : INTEGER;}
BEGIN
  globalResultProtocol := -1;

  WHILE fGlobStopAnzeige DO
    BEGIN {* Nicht sehr elegant, aber CPU-Sparend *}
    Delay(300);
    END;


  IF cHidden THEN opt.fSystemMeldungen := false;
  IF (nDaten = 0) AND opt.fOnlyDataFrames THEN Exit; {* Protokollframes interessieren nicht *}
  IF NOT HostHeaderZerlegen(sHeader,strucH) THEN Exit;

  IF   ( (strucH.PID=$F0)  AND (fCopyReplay=cALL  ) )
    OR ( (strucH.PID<>$F0) AND (fCopyReplay=cFREMD) ) THEN
      BEGIN  {* Replay schreiben *}
      BlockWrite( hdlRepl, sHeader, length(sHeader)+1 );
      BlockWrite( hdlRepl, nDaten, sizeof(nDaten));
      BlockWrite( hdlRepl, aDaten, nDaten);
      END;

  IF (strucH.pid=$BB)    AND NOT opt.fSHOWBC THEN Exit;
  IF (strucH.pid=PID_IP) AND NOT opt.fShowIP THEN Exit;
  {  IF pid=PID_IP THEN Exit; }

  IF (strucH.pid>=0) AND (strucH.pid<=255)  THEN Inc(npid[strucH.pid]);

  {* ggfs. Headersuche *}
  IF opt.suchHead<>cNOSearch THEN
    BEGIN
    IF Pos(opt.sSuchHead, sHeader) = 0
      THEN IF opt.suchHead = cINCL THEN Exit {*nicht gefunden, mode=incl -> Ende  *}
                                   ELSE BEGIN END
      ELSE IF opt.suchHead = cEXCL THEN Exit {* gefunden, mode=excl  -> Ende  *}
    ;
    {* Gefunden: Klingeln und fortsetzen *}
    IF opt.fBeep THEN
      BEGIN
      Beep(1140,150); Delay(50);
      Beep(1140, 50); Delay(50);
      END;
    END;

  {* ggfs Datensuche *}
  IF opt.suchData<>cNOSearch THEN
    BEGIN
    IF MemFind ( aDaten,nDaten, opt.sSuchData ) = -1
      THEN IF opt.suchData = cINCL THEN Exit {*nicht gefunden, mode=incl -> Ende  *}
                                   ELSE BEGIN END
      ELSE IF opt.suchData = cEXCL THEN Exit {* gefunden, mode=excl  -> Ende  *}
    ;
    {* Gefunden: Klingeln und fortsetzen *}
    IF opt.fBeep THEN
      BEGIN
      Beep(1340,50); Delay(50);
      Beep(1340,150); Delay(50);
      END;
    END;

  IF fSingleStep THEN
    BEGIN
    Pausiere('Einzelscritt ');
    END;

  Flush(hdl);
  TextAttr := FARBE_HEADER_AX25_INFO;

  IF sFrameEnde <> '' THEN Writeln(hdl,sFrameEnde);

  sAx25Head := 'AX25';
  IF strucH.port > 1 THEN AddString(sAx25Head, f_liStr(strucH.port)+'');

  AddString(sAx25Head,strucH.sFm+''+strucH.sTo);
  IF strucH.sVia <> '' THEN sAx25Head := sAx25Head+' ('+strucH.sVia+')';
  AddString(sAx25Head,' '+strucH.sFrame);
  IF strucH.PID>=0 THEN sAx25Head := sAx25Head+' '+PID2String(strucH.PID);
  AddString(sAx25Head, '  ' + strucH.sZeit + ' Len:' + f_liStr(nDaten));
  IF (strucH.PID = -1)  THEN
    BEGIN {* Kontrollframes *}
    Flush(hdl);
    SetTextAttr(FARBE_HEADER_AX25_CTRL);
    WriteLn(hdl,sAx25Head);
    Exit;
    END;

 {$IFDEF OS2} IF DosSleep(0) = 0 THEN;;;;; {$ENDIF}

 IF    ((strucH.PID =$F0) AND opt.fShowAx)
    OR ((strucH.PID<>$F0) AND opt.fShowPID)
        THEN
    BEGIN {* Anzeigen *}
    Write(hdl,sAx25Head);
    Flush(hdl);
    SetTextAttr(FARBE_MONI_DEFAULT);
    {* BildSchirm: Daten *}
    IF NOT opt.fAXBodyZeigen
      THEN BEGIN
           Flush(hdl);
           TextAttr := FARBE_HEADER_ZUSATZ;
           WriteLn(hdl);
           Flush(hdl);
           SetTextAttr (FARBE_MONI_DEFAULT );
           END
      ELSE BEGIN
           fShow := (strucH.PID <> $0f0)
                   OR opt.fDatenBinaer
                   OR DatenLesbar(@aDaten[1], nDaten);  {Ax25.purText lesbar?}
           IF fShow
             THEN BEGIN
                  WriteLn(hdl);
                  Dump_AX25 (hdl, strucH.PID, @aDaten, nDaten);
                  Writeln(hdl);
                  END
             ELSE BEGIN { nicht lesbaren purtext (7+,Bins...) ausblenden }
                  Flush(hdl);
                  TextAttr := FARBE_HEADER_ZUSATZ;
                  IF strucH.PID = $0f0 THEN Write(hdl,' "binr"');
                  Writeln(hdl);
                  END;

           {* //Compress & Co. - Kram *}
           IF (strucH.PID = $0f0) AND opt.fSpCompressDecoder THEN
             IF NOT DatenLesbar(@aDaten[1], nDaten) THEN
               BEGIN
               fLocDone := false;
               oblen := 0;
{$IFDEF xorjen}
               XorJenTest(@aDaten[1], nDaten, outbuf, sizeof(outbuf), oblen );
               IF oblen > 0 THEN
                 BEGIN
                 Flush(hdl);
                 SetTextAttr(FARBE_OTHER_TEXTDATA);
                 DumpText (hdl, @aDaten, nDaten, false);
                 WriteLn(hdl);
                 Flush(hdl);
                 SetTextAttr(FARBE_HEADER_MISC);
                 Write (hdl,'XJEN?');
                 Flush(hdl);
                 SetTextAttr(FARBE_OTHER_TEXTDATA);
                 DumpText (hdl, @outbuf, oblen, false);
                 WriteLn(hdl);
                 IF outbuf[1] = ''
                   THEN Dump_AX25 (hdl, PID_IP, @outbuf[2], oblen-1)
                   ELSE Dump_AX25 (hdl, PID_IP, @outbuf, oblen);
                 WriteLn(hdl);
                 fLocDone := true;
                 END;
{$ENDIF}
{ $ DEFINE comp}
{$IFDEF comp}
               IF not fLocDone THEN
                 BEGIN
                 oblen := 0;
                 SpCompressTest(@aDaten[1], nDaten, outbuf, sizeof(outbuf), oblen );
                 IF oblen > 0 THEN
                   IF DatenLesbar(@outbuf[1], oblen) THEN
                     BEGIN
                     Flush(hdl);
                     SetTextAttr(FARBE_HEADER_MISC);
                     Write(hdl,'/COMP?');
                     Flush(hdl);
                     SetTextAttr(FARBE_OTHER_TEXTDATA);
                     DumpText (hdl, @outbuf, oblen,true);
                     WriteLn(hdl);
                     fLocDone := true;
                     END;
                 END;
{$ENDIF}
               END;
           END;
        END; {if showpid/ax}

  {* Platte *}
  IF strucH.PID = $F0
    THEN BEGIN
         DoMailAndSpy (strucH, @aDaten[1], nDaten);
         END
    ELSE BEGIN
         IF (strucH.PID <> $BB) OR NOT opt.fBcRx
           THEN BEGIN
                DoMailAndSpy (strucH,@aDaten[1], nDaten);
                {WriteLn(hdlNotTxt,sAx25Head);
                Dump_AX25 (hdlNotTxt, pid, @aDaten[1], nDaten);
                WriteLn(hdlNotTxt);}
                END
           ELSE BEGIN {* BC-RXen *}
                BC2Work (strucH, @aDaten[1], nDaten);
                END;
         END;
  strucH.resultProtocol:=globalResultProtocol;
END;



FUNCTION fnReplayCopy : T_Replay;
BEGIN
  fnReplayCopy:= fCopyReplay;
END;

PROCEDURE Replay(f:T_Replay; sFileName:STRING);
  var i : WORD;
      fAlt : T_REplay;
BEGIN
  IF f=fCopyReplay THEN Exit;
  fAlt := fCopyReplay;
  fCopyReplay := f;
  IF f=cNO THEN BEGIN
                Close(hdlRepl);
                Exit;
                END;
  IF fAlt <> cNo THEN Exit;

{  IF fileRec(hdlRepl).mode <> fmClosed THEN Exit;}
  IF sFileName = '' THEN sFileName := sLocFileName
                    ELSE sLocFileName := sFileName;
  IF sFileName='' THEN sFileName := 'default.rpl';
  Assign(hdlRepl, sFileName);
  {$I-}
  Reset(hdlrepl,1);
  if IOResult <> 0 THEN Rewrite(hdlRepl,1)
                   ELSE Seek(hdlRepl,filesize(hdlrepl));
  i := IOResult;
  IF i<>0 THEN BEGIN
               WriteLn;
               WriteLn(output,'Can''t write ',sFileName,i:5 );
               Halt(4);
               END;
END;


  VAR ExitSave : Pointer;
PROCEDURE DoExit; FAR;
  VAR i : BYTE;
BEGIN
  FOR i := 1 TO cMAXBCWORK DO SchliesseUnfertige(i);
  CloseAllSpy;
  IF fCopyReplay <> cNO THEN Close(hdlRepl);
  SchreibeIni(csINIFILEINAME, sPgmName+' '+sPgmVersion+' ('+csPlattform+')', MAXOPTINI, @cOptIni[1]);
  Exitproc := exitSave;
END;


BEGIN
  {DOBcFHeader(xh, hdl, FALSE);}
  exitsave := exitproc;
  exitproc := @doexit;

  {$IFDEF os2}
{  IF MaxSpy > 10 THEN }
  IF DosSetMaxFH (maxspy+30)<>0 THEN
    BEGIN
    Write(' Anzahl Handles konnte nicht erhht werden ');
    {MaxSpy := Min(InitMaxSpy,10);}
    END;
    { number of file handles to be provided }
  {$ENDIF}

  MakeHB;
  InitSpy;
  FillChar(nPID, sizeof(nPid), #0 );
{  FillChar(initdat, sizeof(initdat), #$FF ); }
{  FillChar(bcworkVorher, sizeof(bcworkVorher), #0 ); }
  FillChar(aBC, sizeof(aBC), #0 );
  LeseIni( csINIFILEINAME, MAXOPTINI, @cOptIni[1]);
END.



